#version 430 core

uniform sampler2D image;

uniform vec4 scale;
uniform vec4 bias;

uniform bool bloom;

in vec2 uv;

out vec4 result;

void main() {

	vec4 c = texture(image, uv);
	
	if (bloom)
	{
		c = vec4(c.x == 1.0 ? 0:c.x, c.y == 1.0 ? 0:c.y, c.z == 1.0 ? 0:c.z, 1.0);
		float l = 0.0005;
	
		if ( abs(c.x - c.y) > l || abs(c.y - c.z) > l || abs(c.x - c.z) > l )
			c = vec4(0.0);
		
	}
	else 
	{
	// avoiding a little bit the particle lens flare stuff
		if (c.x == 1) c.x = 0.0;
		if (c.y == 1) c.y = 0.0;
		if (c.z == 1) c.z = 0.0;
	}
		
	result = max(vec4(0.0), c + bias) * scale;
	
}