#version 430 core

// variables

layout (location = 0) in vec4 position_type;
layout (location = 1) in vec4 velocity_ttl;
layout (location = 2) in vec4 color_radius;

uniform mat4 projMatrix;
uniform mat4 viewMatrix;

out mat4 modelMatrix0;
out mat4 normalMatrix0;
out mat4 projMatrix0;
out mat4 viewMatrix0;

out vec4 clipSpacePosition0;
out vec3 color0;
out float radius0;


//out vec4 PositionWorld0;

void main(void)
{
	vec3 atomPos = position_type.xyz;
	float atomRad = color_radius.w;
	vec3 atomCol = color_radius.xyz;
	
	
	vec4 objectSpacePos = vec4(0.0, 0.0, 0.0, 1.0);
	mat4 modelMatrix = mat4(vec4(1.0,0,0,0),vec4(0,1.0,0,0),vec4(0,0,1,0),vec4(atomPos,1.0));
	
	mat4 MVP = projMatrix * viewMatrix * modelMatrix;

	gl_Position = MVP * objectSpacePos;
	
	clipSpacePosition0 = gl_Position;
	radius0 = atomRad;
	color0 = atomCol;
	projMatrix0 = projMatrix;
	viewMatrix0 = viewMatrix;
	modelMatrix0 = modelMatrix;
	normalMatrix0 = transpose(inverse(viewMatrix*modelMatrix));


}